
!TOMethodSourceBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/30/2011 19:57'!
accept: aString
	| newSelector |
	newSelector := [ self methodClass compile: aString classified: self methodCategory notifying: nil ]
		on: SyntaxErrorNotification
		do: [ :ex | 
			methodSource := (aString copyFrom: 1 to: ex location) , ex errorMessage , '-->'
				, (aString copyFrom: ex location + 1 to: aString size).
			^ nil ].
	methodSource := nil.
	newSelector == self selectedMethodSelector
		ifTrue: [ ^ self ].
	self methodReference: (MethodReference class: self methodClass selector: newSelector)! !

!TOMethodSourceBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/30/2011 20:42'!
moveMethodTo: cat

	self methodClass organization 
		classify: self selectedMethodSelector
		under: cat
		suppressIfDefault: false.
	self methodReference category: nil.! !

!TOMethodCategoryBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/27/2011 09:14'!
selectorsForCategory: cat

	^(cat = '-- all --'
		ifTrue: [ self theClass selectors ]
		ifFalse: [ self theClass organization listAtCategoryNamed: cat ]) asArray.! !

!TOMethodCategoryBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/26/2011 12:20'!
sortedCategories

	^self theClass organization categories asArray sorted: [:a :b | a <= b ].! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/24/2011 00:29'!
acessesToCV: classVarName from: aClass
	
	^(SystemNavigation default) allCallsOn: (aClass classPool associationAt: classVarName )
! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/24/2011 00:26'!
acessesToIV: instVarName from: aClass
	| coll |
	coll := OrderedCollection new.
	aClass
		withAllSubAndSuperclassesDo: [ :class | 
			(class whichSelectorsAccess: instVarName)
				do: [ :sel | 
					sel isDoIt
						ifFalse: [ coll add: (SourcedMethodReference new setClass: class methodSymbol: sel) ] ] ].
	^ coll! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/24/2011 00:44'!
classDefinitionTemplate: classTemplateType
	| stream |
	classTemplateType == #new
		ifTrue: [ ^ Class templateForSubclassOf: Object name category: self theClass theNonMetaClass category ].

	classTemplateType == #subclass
		ifTrue: [ ^ Class templateForSubclassOf: self theClass name category: self theClass theNonMetaClass category ].
		
	"classTemplateType == #definition"
	stream := WriteStream on: String new.
	stream
		nextPutAll: self theClass definition;
		nextPut: $.;
		cr;
		cr;
		nextPutAll: self theClass class definition;
		nextPut: $.;
		cr.
	^ stream contents! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/28/2011 13:31'!
copyClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/28/2011 13:31'!
removeClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/28/2011 13:31'!
renameClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/28/2011 11:06'!
renderClassExplorerOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			html break.
			self
				renderLink: [ :s | 
					main currentSpace push: self theClass superclass allCallsOn selecting: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass superclass name ]
				on: html.
			html text: ' subclass: '.
			self
				renderLink: [ :s | 
					main currentSpace push: self theClass allCallsOn selecting: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name ]
				on: html.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									main currentSpace push: (self acessesToIV: iv from: self theClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'classVariableNames: '.
					self theClass classVarNames
						do: [ :cv | 
							html space.
							self
								renderLink: [ :s | 
									main currentSpace push: (self acessesToCV: cv from: self theClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: cv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'poolDictionaries: '.
					self theClass theNonMetaClass poolDictionaryNames
						do: [ :sp | 
							self
								renderLink: [ :s | 
									main currentSpace
										push:
											(SystemNavigation default allReferencesToPool: (Smalltalk globals at: sp asSymbol) from: self theClass theNonMetaClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: sp ]
								on: html ] ].
			html
				unorderedList: [ 
					| cat |
					html text: 'category: '.
					cat := self theClass theNonMetaClass category.
					self
						renderLink: [ :s | 
							main currentSpace push: (SystemOrganization classesInCategory: cat) selecting: #inspect.
							main updateCenterSideHistory: s ]
						with: [ html strong: cat ]
						on: html ].
			html break.
			self
				renderLink: [ :s | 
					main currentSpace push: self theClass class allCallsOn selecting: #inspect..
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name , ' class' ]
				on: html.
			html break.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass class instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									main currentSpace push: (self acessesToIV: iv from: self theClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ] ]
		on: html! !
